<template>
  <div class="container-xxl">
    <div class="row mt-5 justify-content-center">
      <div class="col-xxl-8 col-xl-10 col-lg-11">
        <div
          id="subasta_editar_formulario"
          class="card mb-5 mb-xl-8 m-5 shadow-sm"
        >
          <div class="card-header border-2 pt-5">
            <h3 class="card-title align-items-start flex-column">
              <span class="card-label fw-bolder fs-3 mb-1">Editar una subasta</span>
            </h3>
          </div>

          <div class="card-body">
            <div class="row">
              <div class="col-xxl-12 col-form-label">
                <label class="required fw-bolder fs-6">Título</label>
              </div>
              <div class="col-xxl-12">
                <input
                  v-model="mFormulario.titulo"
                  type="text"
                  class="form-control"
                  placeholder=""
                  maxlength="100"
                >
              </div>
            </div>

            <div class="row">
              <div class="col-xxl-4 col-xl-4">
                <div class="row">
                  <div class="col-12 col-form-label">
                    <label class="required fw-bolder fs-6">Peso promedio (kg.)</label>
                  </div>
                  <div class="col-12">
                    <input
                      v-model="mFormulario.pesoPromedio"
                      type="number"
                      step="0.10"
                      class="form-control"
                      placeholder=""
                    >
                  </div>
                </div>
              </div>
              <div class="col-xxl-4 col-xl-4">
                <div class="row">
                  <div class="col-12 col-form-label">
                    <label class="required fw-bolder fs-6">Cantidad de cabezas</label>
                  </div>
                  <div class="col-12">
                    <input
                      v-model="mFormulario.cantidadAnimal"
                      type="number"
                      step="1"
                      class="form-control"
                      placeholder=""
                    >
                  </div>
                </div>
              </div>
              <div class="col-xxl-4 col-xl-4">
                <div class="row">
                  <div class="col-12 col-form-label">
                    <label class="required fw-bolder fs-6">Precio referencial</label>
                  </div>
                  <div class="col-12 input-group">
                    <input
                      v-model="mFormulario.precioReferencial"
                      type="number"
                      step="0.10"
                      class="form-control"
                    >
                    <select
                      v-model="mFormulario.tipoMoneda"
                      class="form-select"
                    >
                      <option
                        selected
                        value="BOB"
                      >
                        BOB
                      </option>
                      <option value="USD">
                        USD
                      </option>
                    </select>
                  </div>
                </div>
              </div>
            </div>

            <div class="row">
              <div class="col-xxl-4 col-xl-4">
                <div class="row">
                  <div class="col-12 col-form-label">
                    <label class="required fw-bolder fs-6">Teléfono del centro</label>
                  </div>
                  <div class="col-12">
                    <input
                      v-model="mFormulario.telefonoCentro"
                      type="tel"
                      class="form-control"
                      placeholder=""
                    >
                  </div>
                </div>
              </div>
              <div class="col-xxl-4 col-xl-4">
                <div class="row">
                  <div class="col-12 col-form-label">
                    <label class="required fw-bolder fs-6">Fecha de la subasta</label>
                  </div>
                  <div class="col-12">
                    <input
                      id="subasta_editar_input_fecha_remate"
                      v-model="mFormulario.fechaRemate"
                      type="text"
                      class="form-control"
                      placeholder=""
                    >
                  </div>
                </div>
              </div>
              <div class="col-xxl-4 col-xl-4">
                <div class="row">
                  <div class="col-12 col-form-label">
                    <label class="required fw-bolder fs-6">Hora de la subasta</label>
                  </div>
                  <div class="col-12">
                    <input
                      id="subasta_editar_input_hora_remate"
                      v-model="mFormulario.horaRemate"
                      type="text"
                      class="form-control"
                      placeholder=""
                    >
                  </div>
                </div>
              </div>
            </div>

            <div class="row mt-4">
              <div class="col-xxl-12">
                <label class="required fw-bolder fs-6">Descripción</label>
              </div>
              <div class="col-xxl-12">
                <editor
                  id="uuid_subasta_editar"
                  v-model="mFormulario.descripcion"
                  api-key="1xeptavkfan6chg28kymlf0z72m52jfulcbiku9gi7jwvo8d"
                  cloud-channel="6"
                  :disabled="false"
                  initial-value=""
                  model-events=""
                  plugins=""
                  tag-name="div"
                  toolbar=""
                />
              </div>
            </div>

            <div class="row mt-4">
              <div class="col-xxl-12">
                <label class="required fw-bolder fs-6">Geolocalización</label>
              </div>
              <div class="col-xxl-12">
                <GoogleMap
                  api-key="AIzaSyA2XeZf5gGUwUTKl9y-hq2GsMdTlCJCgds"
                  style="width: 100%; height: 500px"
                  :center="{lat: mFormulario.latitud, lng: mFormulario.longitud}"
                  :zoom="7"
                >
                  <Marker
                    :options="{ position: {lat: mFormulario.latitud, lng: mFormulario.longitud}, draggable: true, clickable: true }"
                    @dragend="onGeolocalizacionActualizar($event)"
                  />
                </GoogleMap>
              </div>
            </div>
          </div>
          <div class="card-footer border-2 pb-4 text-end">
            <button
              type="reset"
              class="btn btn-light me-3"
            >
              Cancel
            </button>
            <button
              id="subasta_editar_btn_guardar"
              type="button"
              class="btn btn-primary"
              @click="onSubastaModificar()"
            >
              <span class="indicator-label">Guardar</span>
              <span class="indicator-progress">
                Espere por favor... <span class="spinner-border spinner-border-sm align-middle ms-2" />
              </span>
            </button>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
import BloqueoUI from "@/core/util/BloqueoUI";
import flatpickr from "flatpickr";
import { Spanish } from "flatpickr/dist/l10n/es.js";
import Editor from '@tinymce/tinymce-vue';
import { GoogleMap, Marker } from "vue3-google-map";
import Servicio from "@/core/servicio/Servicio";
import Ruta from "@/core/servicio/Ruta";
import Toast from "@/core/util/Toast";
import Alerta from "@/core/util/Alerta";
import router from "@/router";

export default {
  name: 'SubastaEditar',
  components: {
    Editor,  GoogleMap, Marker
  },

  data() {
    return {
      componentes: {
        bloqueoUI: null,
      },
      mFormulario: {
        titulo: '',
        pesoPromedio: '',
        cantidadAnimal: '',
        precioReferencial: '',
        tipoMoneda: 'BOB',
        telefonoCentro: '',
        descripcion: '',
        fechaRemate: '',
        horaRemate: '',
        latitud: -17.783602,
        longitud: -63.182327,
      }
    };
  },

  mounted() {
    flatpickr("#subasta_editar_input_fecha_remate", {
      "locale": Spanish
    });
    flatpickr("#subasta_editar_input_hora_remate", {
      enableTime: true,
      noCalendar: true,
      dateFormat: "H:i:s",
      time_24hr: true
    });
    this.componentes.bloqueoUI = new BloqueoUI('#subasta_editar_formulario', '#subasta_editar_btn_guardar');
    this.onSubastaEditar();
  },
  methods: {
    onSubastaEditar() {
      Servicio.get(Ruta.rutaPanelSubastaMostrar(this.$route.params.id)).then( (data) => {
        this.mFormulario = data.data;
      }).catch( (error) => {
        this.response.mostrar = 'ERROR';
        Toast.mostrarError(error);
      });
    },

    onSubastaModificar() {
      this.componentes.bloqueoUI.iniciarBloqueoFormulario();
      Servicio.postMultiPart(Ruta.rutaPanelSubastaModificar(this.$route.params.id), this.mFormulario).then( (data) => {
        Toast.mostrarExito(data.mensaje);
        this.componentes.bloqueoUI.terminarBloqueoFormulario();
        router.push({name: 'panel.subasta.listar'});
      }).catch((error) => {
        this.componentes.bloqueoUI.terminarBloqueoFormulario();
        Alerta.alertaError(error);
      });
    },

    onGeolocalizacionActualizar(event) {
      this.mFormulario.latitud = event.latLng.lat();
      this.mFormulario.longitud = event.latLng.lng();
    }
  }
}
</script>